javax.jdo

## Class JDOException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - java.lang.RuntimeException
      - - javax.jdo.JDOException

- All Implemented Interfaces:
    Serializable
  Direct Known Subclasses:
    JDOCanRetryException, JDOEnhanceException, JDOFatalException

      public class JDOException
      extends RuntimeException

  This is the root of all JDO Exceptions. It contains an optional detail message, an optional nested `Throwable` array and an optional failed object.
  Version:
    1.0.2
  Author:
    Craig Russell
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `JDOException()` Constructs a new `JDOException` without a detail message.
    `JDOException(String msg)` Constructs a new `JDOException` with the specified detail message.
    `JDOException(String msg, Object failed)` Constructs a new `JDOException` with the specified detail message and failed object.
    `JDOException(String msg, Throwable nested)` Constructs a new `JDOException` with the specified detail message and nested `Throwable`.
    `JDOException(String msg, Throwable[] nested)` Constructs a new `JDOException` with the specified detail message and nested `Throwable`s.
    `JDOException(String msg, Throwable[] nested, Object failed)` Constructs a new `JDOException` with the specified detail message, nested `Throwable`s, and failed object.
    `JDOException(String msg, Throwable nested, Object failed)` Constructs a new `JDOException` with the specified detail message, nested `Throwable`, and failed object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Throwable` | `getCause()` Often there is only one nested exception, and this method returns it.
    `Object` | `getFailedObject()` The exception may include a failed object.
    `Throwable[]` | `getNestedExceptions()` The exception may have been caused by multiple exceptions in the runtime.
    `Throwable` | `initCause(Throwable cause)` JDK 1.4 includes a new chaining mechanism for Throwable, but since JDO has its own "legacy" chaining mechanism, the "standard" mechanism cannot be used.
    `void` | `printStackTrace()` Prints this `JDOException` and its backtrace to the standard error output.
    `void` | `printStackTrace(PrintStream s)` Prints this `JDOException` and its backtrace to the specified print stream.
    `void` | `printStackTrace(PrintWriter s)` Prints this `JDOException` and its backtrace to the specified print writer.
    `String` | `toString()` The `String` representation includes the name of the class, the descriptive comment (if any), the `String` representation of the failed `Object` (if any), and the `String` representation of the nested `Throwable`s (if any).

    - ### Methods inherited from class java.lang.Throwable

      `addSuppressed, fillInStackTrace, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, setStackTrace`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### JDOException

          public JDOException()

      Constructs a new `JDOException` without a detail message.

    - #### JDOException

          public JDOException(String msg)

      Constructs a new `JDOException` with the specified detail message.
      Parameters:
        `msg` - the detail message.

    - #### JDOException

          public JDOException(String msg,
                              Throwable[] nested)

      Constructs a new `JDOException` with the specified detail message and nested `Throwable`s.
      Parameters:
        `msg` - the detail message.
        `nested` - the nested `Throwable[]`.

    - #### JDOException

          public JDOException(String msg,
                              Throwable nested)

      Constructs a new `JDOException` with the specified detail message and nested `Throwable`.
      Parameters:
        `msg` - the detail message.
        `nested` - the nested `Throwable`.

    - #### JDOException

          public JDOException(String msg,
                              Object failed)

      Constructs a new `JDOException` with the specified detail message and failed object.
      Parameters:
        `msg` - the detail message.
        `failed` - the failed object.

    - #### JDOException

          public JDOException(String msg,
                              Throwable[] nested,
                              Object failed)

      Constructs a new `JDOException` with the specified detail message, nested `Throwable`s, and failed object.
      Parameters:
        `msg` - the detail message.
        `nested` - the nested `Throwable[]`.
        `failed` - the failed object.

    - #### JDOException

          public JDOException(String msg,
                              Throwable nested,
                              Object failed)

      Constructs a new `JDOException` with the specified detail message, nested `Throwable`, and failed object.
      Parameters:
        `msg` - the detail message.
        `nested` - the nested `Throwable`.
        `failed` - the failed object.

  - ### Method Detail

    - #### getFailedObject

          public Object getFailedObject()

      The exception may include a failed object.
      Returns:
        the failed object.

    - #### getNestedExceptions

          public Throwable[] getNestedExceptions()

      The exception may have been caused by multiple exceptions in the runtime. If multiple objects caused the problem, each failed object will have its own `Exception`.
      Returns:
        the nested Throwable array.

    - #### getCause

          public Throwable getCause()

      Often there is only one nested exception, and this method returns it. If there are more than one, then this method returns the first nested exception. If there is no nested exception, then null is returned.
      Overrides:
        `getCause` in class `Throwable`
      Returns:
        the first or only nested Throwable.
      Since:
        1.0.1

    - #### initCause

          public Throwable initCause(Throwable cause)

      JDK 1.4 includes a new chaining mechanism for Throwable, but since JDO has its own "legacy" chaining mechanism, the "standard" mechanism cannot be used. This method always throws a JDOFatalInternalException.
      Overrides:
        `initCause` in class `Throwable`
      Parameters:
        `cause` - ignored.
      Returns:
        never.

    - #### toString

          public String toString()

      The `String` representation includes the name of the class, the descriptive comment (if any), the `String` representation of the failed `Object` (if any), and the `String` representation of the nested `Throwable`s (if any).
      Overrides:
        `toString` in class `Throwable`
      Returns:
        the `String`.

    - #### printStackTrace

          public void printStackTrace()

      Prints this `JDOException` and its backtrace to the standard error output. Print nested Throwables' stack trace as well.
      Overrides:
        `printStackTrace` in class `Throwable`

    - #### printStackTrace

          public void printStackTrace(PrintStream s)

      Prints this `JDOException` and its backtrace to the specified print stream. Print nested Throwables' stack trace as well.
      Overrides:
        `printStackTrace` in class `Throwable`
      Parameters:
        `s` - `PrintStream` to use for output

    - #### printStackTrace

          public void printStackTrace(PrintWriter s)

      Prints this `JDOException` and its backtrace to the specified print writer. Print nested Throwables' stack trace as well.
      Overrides:
        `printStackTrace` in class `Throwable`
      Parameters:
        `s` - `PrintWriter` to use for output

Copyright © 2005–2022 The Apache Software Foundation. All rights reserved.